import * as mc from '@minecraft/server';

mc.system.runInterval(() => {
    let players = mc.world.getAllPlayers();
    players.forEach(player => {
    if (player.hasTag('tc_the_empress') || player.hasTag('tc_the_empress2')) {

       player.runCommand("event entity @e[r=3] minecraft:ageable_grow_up");
     }
  })
}, 3000);

mc.system.runInterval(() => {
    let players = mc.world.getAllPlayers();
    players.forEach(player => {
    if (player.hasTag('tc_temperance') || player.hasTag('tc_temperance2')) {

       player.addEffect('saturation', 20, { amplifier: 0, showParticles: false });
     }
  })
}, 1200);

mc.system.runInterval(() => {
    let players = mc.world.getAllPlayers();
    players.forEach(player => {
    if (player.hasTag('tc_the_hermit') || player.hasTag('tc_the_hermit2')) {

       let entities = player.dimension.getEntities({location:player.location, minDistance: 1, maxDistance: 10})
       entities.forEach(entity => {
        if (entity.hasComponent('minecraft:is_tamed') || entity.typeId == "minecraft:player") {

            player.addTag('tc_the_hermit3');

          }
        })

       if (!player.hasTag('tc_the_hermit3')) {

player.addEffect('resistance', 20, { amplifier: 0, showParticles: true });
     }

     player.removeTag('tc_the_hermit3')
}

     if (player.hasTag('tc_the_lovers') || player.hasTag('tc_the_lovers2')) {

       let entities = player.dimension.getEntities({location:player.location, minDistance: 1, maxDistance: 5})
       entities.forEach(entity => {
        if (entity.hasComponent('minecraft:is_tamed') || entity.typeId == "minecraft:player") {
           entity.addEffect('regeneration', 20, { amplifier: 2, showParticles: true });
          }
        })
     }
  })
}, 1);

mc.world.afterEvents.entityHurt.subscribe(async data => {
    const target = data.hurtEntity;
    const attacker = data.damageSource.damagingEntity;
    const damage = data.damage;
    const undead = [
    "minecraft:drowned",
    "minecraft:husk",
    "minecraft:phantom",
    "minecraft:skeleton",
    "minecraft:skeleton_horse",
    "minecraft:stray",
    "minecraft:wither_skeleton",
    "minecraft:zoglin",
    "minecraft:zombie",
    "minecraft:zombie_horse",
    "minecraft:zombie_pigman",
    "minecraft:zombie_villager"
    ];

    if (!target) {

         return;
    }

    if (target.typeId == "minecraft:player") { 
    if (target.hasTag('tc_the_hanged_man') || target.hasTag('tc_the_hanged_man2')) {

        const exp = Math.floor(damage / 2);
        target.runCommand(`xp ${exp} @s`);
    }
}

    if (!attacker) {

         return;
    }

    if (attacker.hasTag('tc_death') || attacker.hasTag('tc_death2')) {
        if (!undead.includes(target.typeId)) {

         mc.system.runTimeout(() => {
             target.applyDamage(Math.floor(damage / 5));
                }, 10);
          }
    }

    if (attacker.hasTag('tc_judgement') || attacker.hasTag('tc_judgement2')) {
       var chance = Math.floor(Math.random() * 100) + 1;
       if (chance <= 15) {

          mc.system.runTimeout(() => {
             target.applyDamage(damage);
                }, 10);
          }
    }


    if (target.hasTag('tc_justice') || target.hasTag('tc_justice2')) {

       attacker.applyDamage(Math.floor(damage / 4));
    }

    if (attacker.hasTag('tc_the_devil') || attacker.hasTag('tc_the_devil2')) {
        
         target.addEffect('weakness', 60, { amplifier: 0, showParticles: true });
    }
});

mc.world.afterEvents.playerBreakBlock.subscribe(async (data) => {
    let { player, itemStackBeforeBreak: item } = data;
    let block = data.brokenBlockPermutation;
    let blockType = block.type.id;
    if (block) {
       if (player.hasTag('tc_the_hierophant') || player.hasTag('tc_the_hierophant2')) {

           if (blockType == "minecraft:coal_ore" || blockType == "minecraft:deepslate_coal_ore" || blockType == "minecraft:nether_gold_ore" || blockType == "minecraft:sculk") {

              player.runCommand("xp 1 @s");
           }

           if (blockType == "minecraft:deepslate_redstone_ore" || blockType == "minecraft:lit_deepslate_redstone_ore" || blockType == "minecraft:redstone_ore" || blockType == "minecraft:lit_redstone_ore" || blockType == "minecraft:lapis_ore" || blockType == "minecraft:deepslate_lapis_ore" || blockType == "minecraft:quartz_ore" || blockType == "minecraft:skulk_sensor" || blockType == "minecraft:sculk_shrieker" || blockType == "minecraft:sculk_catalyst") {

              player.runCommand("xp 2 @s");
           }

           if (blockType == "minecraft:diamond_ore" || blockType == "minecraft:deepslate_diamond_ore" || blockType == "minecraft:emerald_ore" || blockType == "minecraft:deepslate_emerald_ore") {

              player.runCommand("xp 3 @s");
           }

           if (blockType == "minecraft:mob_spawner") {

              player.runCommand("xp 15 @s");
           }
        }
        
    if (player.hasTag('tc_wheel_of_fortune')  || player.hasTag('tc_wheel_of_fortune2')) {
      
      if (blockType == "minecraft:coal_ore" || blockType == "minecraft:deepslate_coal_ore") {

         player.runCommand("function tc_coal")
      }
      
      if (blockType == "minecraft:copper_ore" || blockType == "minecraft:deepslate_copper_ore") {

         player.runCommand("function tc_raw_copper")
      }
      
      if (blockType == "minecraft:iron_ore" || blockType == "minecraft:deepslate_iron_ore") {

         player.runCommand("function tc_raw_iron")
      }
      
      if (blockType == "minecraft:gold_ore" || blockType == "minecraft:deepslate_gold_ore") {

         player.runCommand("function tc_raw_gold")
      }
      
      if (blockType == "minecraft:lapis_ore" || blockType == "minecraft:deepslate_lapis_ore") {

         player.runCommand("function tc_lapis")
      }
      
      if (blockType == "minecraft:redstone_ore" || blockType == "minecraft:lit_redstone_ore" || blockType == "minecraft:deepslate_redstone_ore" || blockType == "minecraft:lit_deepslate_redstone_ore") {

         player.runCommand("function tc_redstone")
      }
      
      if (blockType == "minecraft:diamond_ore" || blockType == "minecraft:deepslate_diamond_ore") {

         player.runCommand("function tc_diamond")
      }
      
      if (blockType == "minecraft:emerald_ore" || blockType == "minecraft:deepslate_emerald_ore") {

         player.runCommand("function tc_emerald")
      }
      
      if (blockType == "minecraft:nether_gold_ore") {

         player.runCommand("function tc_gold_nugget")
      }
      
      if (blockType == "minecraft:quartz_ore") {

         player.runCommand("function tc_quartz")
      }
  }}
    
    if (item) {
        let inv = player.getComponent("inventory")?.container;
        if (inv) {
           if (player.hasTag('tc_the_magician') || player.hasTag('tc_the_magician2')) {
            if (item.typeId == "minecraft:golden_sword" || item.typeId == "minecraft:golden_pickaxe" || item.typeId == "minecraft:golden_axe" || item.typeId == "minecraft:golden_shovel" || item.typeId == "minecraft:golden_hoe") {

                inv.setItem(player.selectedSlot, item);
        }}
    }}
});

mc.world.afterEvents.entityDie.subscribe(async data => {
    const target = data.deadEntity;
    const attacker = data.damageSource.damagingEntity;
    const typea = [
    "minecraft:drowned",
    "minecraft:husk",
    "minecraft:zombie",
    "minecraft:zombie_pigman",
    "minecraft:zombie_villager"
];
    const typeb = [
    "minecraft:agent",
    "minecraft:allay",
    "minecraft:bat",
    "minecraft:iron_golem",
    "minecraft:npc",
    "minecraft:player",
    "minecraft:snow_golem",
    "minecraft:tadpole",
    "minecraft:villager",
    "minecraft:wandering_trader"
];
    const typec = [
    "minecraft:blaze",
    "minecraft:elder_guardian",
    "minecraft:evoker",
    "minecraft:guardian"
];
    const typed = [
    "minecraft:piglin_brute",
    "minecraft:ravager"
];

    if (!target || !attacker) {

         return;
    }

    if (attacker.hasTag('tc_the_hierophant') || attacker.hasTag('tc_the_hierophant2')) {

    if (!target.hasComponent('minecraft:is_baby') && !typea.includes(target.typeId) && !typeb.includes(target.typeId) && !typec.includes(target.typeId) && !typed.includes(target.typeId) && target.typeId != "minecraft:ender_dragon" && target.typeId != "minecraft:wither") {

         attacker.runCommand("xp 2 @s");
    }
    else if (target.hasComponent('minecraft:is_baby') && typea.includes(target.typeId) || typec.includes(target.typeId)) {
        
         target.runCommand("xp 5 @s");
    }
    else if (typed.includes(target.typeId)) {
        
         target.runCommand("xp 10 @s");
    }
    else if (target.typeId == "minecraft:wither") {
        
         target.runCommand("xp 25 @s");
    }
    else if (target.typeId == "minecraft:ender_dragon") {
        
         target.runCommand("xp 250 @s");
    }}
});

mc.world.afterEvents.itemUse.subscribe( async(data) => {
  let player = data.source;
  let item = data.itemStack;
  let enchant = item?.getComponent("enchantable");
  let inv = player.getComponent("inventory")?.container;
  const enchList = enchant?.getEnchantments();
  if (inv && enchant && enchList && item.typeId == "minecraft:enchanted_book") {
     if (player.hasTag('tc_the_high_priestess') || player.hasTag('tc_the_high_priestess2')) {

     if (player.level >= 3) {

        let changed = false;
        for(const e of enchList) {
        let levelMax = e.type["maxLevel"]
        const level = enchList[e.level]
        if (e && e.level < levelMax) {
        e.level += 1;
        enchant.removeEnchantment(e.type)
        enchant.addEnchantment(e);
        player.addLevels(-3);
        changed = true;
        if(changed){
            inv.setItem(player.selectedSlot, item);
                }
            }
        }}
    }}
});

mc.world.afterEvents.entityHitEntity.subscribe( data => {
    const attacker = data.damagingEntity;
    const inv = attacker.getComponent("minecraft:inventory").container;
    const item = inv.getItem(attacker.selectedSlot);

    if (item && inv) {
    if (attacker.hasTag('tc_the_magician') || attacker.hasTag('tc_the_magician2')) {
    if (item.typeId == "minecraft:golden_sword" || item.typeId == "minecraft:golden_pickaxe" || item.typeId == "minecraft:golden_axe" || item.typeId == "minecraft:golden_shovel" || item.typeId == "minecraft:golden_hoe") {
       let durability = item.getComponent("durability");
       let maxDurability = item.getComponent("durability")?.maxDurability;
       let damage = item.getComponent("durability")?.damage;

       if (damage === maxDurability) {
             inv.setItem(attacker.selectedSlot, undefined);
       } else {

         durability.damage -= 1;
         inv.setItem(attacker.selectedSlot, item);
        }}
    }}
});